import uuid

from django.http import JsonResponse
from django.shortcuts import render
from dwebsocket import accept_websocket


def user_a(request):
    """
    A用户 即时通信页面
    :param request:
    :return:
    """
    return render(request, 'user-a.html')


def user_b(request):
    """
    B用户 即时通信页面
    :param request:
    :return:
    """
    return render(request, 'user-b.html')


# 此处若只有两人通信，可以做以下操作
# 若用户有很多人，建议对建立通信的两人进行分组管理
userA = {}
userB = {}


@accept_websocket
def socket_a(request):
    """
    用户A 建立 Socket 通信
    :param request:
    :return:
    """
    if request.is_websocket():
        userid = str(uuid.uuid1())
        # 判断是否有客户端发来消息，若有则进行处理，若发来“test”表示客户端与服务器建立链接成功
        while True:
            message = request.websocket.wait()
            if not message:
                break
            else:
                print("客户端链接成功：" + str(message, encoding="utf-8"))
                # 保存客户端的ws对象，以便给客户端发送消息,每个客户端分配一个唯一标识
                userA[userid] = request.websocket
                # 发送消息
                send_msg(message, userB)


@accept_websocket
def socket_b(request):
    """
    用户B 建立 Socket 通信
    :param request:
    :return:
    """
    if request.is_websocket():
        userid = str(uuid.uuid1())
        # 判断是否有客户端发来消息，若有则进行处理，若发来“test”表示客户端与服务器建立链接成功
        while True:
            message = request.websocket.wait()
            if not message:
                break
            else:
                print("客户端链接成功：" + str(message, encoding="utf-8"))
                # 保存客户端的ws对象，以便给客户端发送消息,每个客户端分配一个唯一标识
                userB[userid] = request.websocket
                send_msg(message, userA)


def send_msg(msg, clients):
    """
    转发消息
    :param msg: 消息内容
    :param client: 接收用户唯一标识
    :return:
    """
    # 若多人中两人进行通信，无需遍历，指定分组管理的用户客户端即可
    for client in clients:
        clients[client].send(msg)
        return JsonResponse({"msg": "success"})
